//DFS rekursiv
vector<list<int> > graph;
vector<bool> visited(n);

void dfs(int node){
    if(!visited[node]){
        visited[node] = true;
        for(int adjacent : graph[node])
            dfs(adjacent);
    }
}

int main()
{
    for(int node : graph)
        if(!visited)
            dfs(node);
}




//DFS iterativ
vector<list<int> > graph;

void dfs(int node){
    vector<bool> visited(n);
    stack<int> st;

    st.push(node);
    while(!st.empty()){
        int cNode = st.top();
        st.pop();

        if(!visited[cNode]){
            visited[cNode] = true;
            for(int adjacent : graph[cNode])
                st.push(adjacent);
        }
    }
}




//BFS
vector<list<int> > graph;

void bfs(int node){
    vector<bool> visited(n);
    queue<int> q;

    q.push(node);
    while(!q.empty()){
        int cNode = q.front();
        q.pop();

        if(!visited[cNode]){
            visited[cNode] = true;
            for(int adjacent : graph[cNode])
                q.push(adjacent);
        }
    }
}




//path existence
vector<list<int> > graph;

bool existsPath(int node, int destination){
    vector<bool> visited(n);
    stack<int> st;

    st.push(node);
    while(!st.empty()){
        int cNode = st.top();
        st.pop();

        if(cNode == destination)
            return true;

        if(!visited[cNode]){
            visited[cNode] = true;
            for(int adjacent : graph[cNode])
                st.push(adjacent);
        }
    }
    return false;
}




//connectivity of a graph
vector<list<int> > graph;

bool connected(int node){
    vector<bool> visited(n);
    stack<int> st;

    st.push(node);
    int i = 0;
    while(!st.empty()){
        int cNode = st.top();
        st.pop();

        if(!visited[cNode]){
        	i++;
            visited[cNode] = true;
            for(int adjacent : graph[cNode])
                st.push(adjacent);
        }
    }
    if(i == n)
        return true;
}




//cycle detection
vector<list<int> > graph;
vector<bool> visited(n);

bool dfs(int node, int parent){
    if(!visited[node]){
        visited[node] = true;
        for(int adjacent : graph[node]){
            if(visited[adjacent] && adjacent != parent)
                return true;
            if(dfs(adjacent))
                return true;
        }
    }
    return false;
}




//find shortest Path
vector<list<int> > graph;

void shortestPath(int node, int goal){
    vector<bool> parent(n, -1);
    queue<int> q;

    q.push(node);
    while(!q.empty()){
        int cNode = q.front();
        q.pop();

        for(int adjacent : graph[cNode])
            if(parent[adjacent] == -1){
                parent[adjacent] = cNode;
                if(adjacent == goal)
                    break;
                q.push(adjacent);
            }
    }
}




//Dijkstra
struct distNode {int distance, int node};
vector<list<distNode> >;

void dijkstra(int node){
    vector<bool> distance(n, INT_MAX);
    priority_queue<distNode>;

    q.push({0, node});
    while(!q.empty()){
        distNode cNode = q.front();
        q.pop();

        if(cNode.distance < distance[cNode.node])
        {
            distance[cNode.node] = cNode.distance;
            for(auto adjacent : graph[cNode.node])
                q.push({cNode.distance + adjacent.distance, adjacent.node});
        }
    }
}




//bipartite check
vector<list<int> > graph;

bool bipartite(int node){
    vector<int> colour(n, -1);
    stack<int> st;

    st.push(node);
    while(!st.empty()){
        int cNode = st.top();
        st.pop();

        for(int adjacent : graph[cNode]){
            if(colour[adjacent] == -1){
                colour[adjacent] = (color[cNode] + 1) % 2
                st.push(adjacent);
            }
            else if(colour[adjacent] == colour[cNode])
                return false;
        }
    }
    return true;
}




//cycle detection in directed Graph
vector<list<int> > graph;
vector<bool> visited(n);
vector<bool> behind(n);

bool dfs(int node, int parent){
    if(!visited[node]){
        visited[node] = true;
        behind[node] = true;

        for(int adjacent : graph[node]){
            if(behind[adjacent] && adjacent != parent)
                return true;
            if(dfs(adjacent))
                return true;
        }

        behind[node] = false;
    }
    return false;
}




//topological sorting of DAG
vector<list<int> > graph;
vector<bool> visited(n);
vector<int> sorted(n);
int counter = 0;

void dfs(int node){
    if(!visited[node]){
        visited[node] = true;
        for(int adjacent : graph[node])
            dfs(adjacent);

        sorted[counter++] = node;
    }
}
